<?php

/* Customizer API | By Qassim Hassan | wp-time.com */

// Sanitize radio input
function ct_sanitize_radio($input){
	if( $input == 'no' ){
		return 'no';
	}

	elseif( $input == 'yes' ){
		return 'yes';
	}

	else{
		return 'sometime';
	}
}


// Sanitize checkbox input
function ct_sanitize_checkbox($input){
	if( $input == 1 ){
		return 1;
	}

	else{
		return '';
	}
}


// Sanitize select option
function ct_sanitize_select($option){
	$array = array('qassim', 'hassan', 'alobaidi');

	if( in_array($option, $array) ){
		return $option;
	}

	else{
		return "qassim";
	}
}


function add_customizer($wp_customize) {
	// Add a new section (Body section)
	$wp_customize->add_section( 'ct_body_section', array(
		'title' => 'Body'
	) );

	// Add a new option to Body Section
	$wp_customize->add_setting( 'op_body_bg_color', array(
		'type' => 'option',
		'default' => '#ffffff', // the default value, you can change it.
		'transport' => 'refresh',
		'sanitize_callback' => 'sanitize_hex_color'
	) );

	// Color option control
	$wp_customize->add_control( new WP_Customize_Color_Control( $wp_customize, 'op_body_bg_color', array(
		'label' => 'Background Color',
		'section' => 'ct_body_section',
		'description' => 'Change body background color.',
		'settings' => 'op_body_bg_color'
	) ) );


	/* -------------------------- */


	// Add a new section (Logo section)
	$wp_customize->add_section( 'ct_logo_section', array(
		'title' => 'Logo'
	) );

	$wp_customize->add_setting( 'op_logo_url', array(
		'type' => 'option',
		'default' => '',
		'transport' => 'refresh',
		'sanitize_callback' => 'esc_url_raw'
	) );
	
	$wp_customize->add_control( new WP_Customize_Image_Control( $wp_customize, 'op_logo_url', array(
		'label' => 'Upload Logo',
		'section' => 'ct_logo_section',
		'description' => 'Upload your logo image.',
		'settings' => 'op_logo_url'
	) ) );
	/*
		Logo Option Output:
			<?php if ( get_option('op_logo_url') ) : ?>
    			<img src="<?php echo esc_url( get_option('op_logo_url') ); ?>">
			<?php endif; ?>
	*/


	/* -------------------------- */


	// Add a new section (More Options section)
	$wp_customize->add_section( 'ct_more_options_section', array(
		'title' => 'More Options'
	) );

	// Text Input Option
	$wp_customize->add_setting( 'op_text_input', array(
		'type' => 'option',
		'default' => '',
		'transport' => 'refresh',
		'sanitize_callback' => 'sanitize_text_field'
	) );

	$wp_customize->add_control( new WP_Customize_Control( $wp_customize, 'op_text_input', array(
		'label' => 'Text Input',
		'type'  => 'text',
		'section' => 'ct_more_options_section',
		'description' => 'An example for text input option.',
		'settings' => 'op_text_input'
	) ) );
	/*
		Text Input Option Output:
			echo get_option('op_text_input');
	*/

	// Textarea Option
	$wp_customize->add_setting( 'op_textarea', array(
		'type' => 'option',
		'default' => '',
		'transport' => 'refresh',
		'sanitize_callback' => 'wp_kses_post'
	) );

	$wp_customize->add_control( new WP_Customize_Control( $wp_customize, 'op_textarea', array(
		'label' => 'Textarea Field',
		'type'  => 'textarea',
		'section' => 'ct_more_options_section',
		'description' => 'An example for textarea option with allow HTML tags.',
		'settings' => 'op_textarea'
	) ) );
	/*
		Textarea Option Output:
			echo get_option('op_textarea');
	*/

	// Checkbox Option
	$wp_customize->add_setting( 'op_checkbox', array(
		'type' => 'option',
		'default' => '', // default option is unchecked, to be checked enter '1'
		'transport' => 'refresh',
		'sanitize_callback' => 'ct_sanitize_checkbox'
	) );

	$wp_customize->add_control( new WP_Customize_Control( $wp_customize, 'op_checkbox', array(
		'label' => 'Checkbox Option',
		'type'  => 'checkbox',
		'section' => 'ct_more_options_section',
		'description' => 'An example for checkbox option.',
		'settings' => 'op_checkbox'
	) ) );
	/*
		Checkbox Option Output:
			if( get_option('op_checkbox') ){
				do something
			}

			Or:
			echo get_option('op_checkbox');
	*/

	// Radio Options
	$wp_customize->add_setting( 'op_radio', array(
		'type' => 'option',
		'default' => 'sometime', // the default value is 'sometime', you can remove the default value.
		'transport' => 'refresh',
		'sanitize_callback' => 'ct_sanitize_radio'
	) );

	$wp_customize->add_control( new WP_Customize_Control( $wp_customize, 'op_radio', array(
		'label' => 'Radio Options',
		'type'  => 'radio',
		'choices' => array( 'no' => 'I am not a smoker.', 'yes'  => 'Yes I am smoker.', 'sometime' => 'I smoke sometimes.' ),
		'section' => 'ct_more_options_section',
		'description' => 'An example for radio options. Do you smoke?',
		'settings' => 'op_radio'
	) ) );
	/*
		Radio Options Output:
			if( get_option('op_radio') ){
				do something
			}

			Or:
			if( get_option('op_radio') == 'no' ){
				do something
			}

			Or:
			echo get_option('op_radio');
	*/

	// Select Options
	$wp_customize->add_setting( 'op_select', array(
		'type' => 'option',
		'default' => 'qassim', // the default value is 'qassim', you can remove the default value.
		'transport' => 'refresh',
		'sanitize_callback' => 'ct_sanitize_select'
	) );

	$wp_customize->add_control( 'op_select', array(
        'settings'		=> 'op_select',
        'label'   		=> 'Select Options',
        'section' 		=> 'ct_more_options_section',
        'description' 	=> 'An example for select options. What is your name?',
        'type'    		=> 'select',
        'choices'    	=> array('qassim' => 'My name is Qassim', 'hassan' => 'My name is Hassan', 'alobaidi' => 'My name is Alobaidi'),
    ));
    /*
		Select Options Output:
			if( get_option('op_select') ){
				do something
			}

			Or:
			if( get_option('op_select') == 'hassan' ){
				do something
			}

			Or:
			echo get_option('op_select');
	*/
}
add_action( 'customize_register', 'add_customizer' );


// Display body background color style in your theme
function body_background_color_style(){
	if( get_option('op_body_bg_color') ){
		?>
			<style type="text/css">
				body{
					background-color: <?php echo get_option('op_body_bg_color'); ?>;
				}
			</style>
		<?php
	}
}
add_action('wp_head', 'body_background_color_style');